#include <stdio.h>
#include <stdlib.h>
#include <strings.h>

#include "election_def.h"

/************************************************
*
*   GLOBALS - used for printout.  At the moment the output is HTML table style.
*
*************************************************/

char tron[] = "<tr>\n";
char troff[] = "</tr>\n";
char ton[] = "<table border=1>\n\n";
char toff[] = "\n\n</table>\n";
char tdon[] = "<td align=center>";
char tdoff[] = "</td>";

char jexcstr[] = "<font color=orange>X</font>";
char excstr[] = "<font color=red>x</font>";
char jelectedstr[] = "<font color=green>E</font>";
char electedstr[] = "<font color=green>e</font>";



/*******************************************************************************
*
*  Output functions.
*
********************************************************************************/


void sort_candidates_alpha(electionDef *myE) {
 
    memcpy (myE->alphaCandidates, myE->candidates, myE->totalCandidateCount * sizeof(candidateDef));
    
    qsort (myE->alphaCandidates, myE->totalCandidateCount, sizeof(candidateDef), &sortAlpha);
    
}

int sortAlpha (const void *in1, const void *in2) {
    
    candidateDef *c1 = (candidateDef *) in1;
    candidateDef *c2 = (candidateDef *) in2;
    
    if (c1->pcode > c2->pcode) {
        return 1;
    }
    else if (c1->pcode < c2->pcode) {
        return -1;
    }
    else {

        return strcmp(c1->name, c2->name);
    }
    
}




void print_help() {
    
    printf("\nRequired arguments:\n");
 //   printf("-vancancies num_vacancies\n");
    printf("-electorates electorates_file\n");
    printf("-parties party_file\n");
    printf("-candidates candidates_file\n");
    printf("-ballots ballots_file\n");
    printf("\n\n");
}


void printRound(electionDef *myE, int countNum, int *theseVotes, int exhaustCount, tValDef tVal) {
    int i;
    
    printf(tron);
    
    printf("%s%d%s", tdon, countNum, tdoff);
    
    for (i = 0; i < myE->totalCandidateCount ; i++) {
        
        if (myE->candidates[myE->alphaCandidates[i].index].status == justelected) {
            printf("%s%s%s", tdon, jelectedstr, tdoff);
            
        } else if (myE->candidates[myE->alphaCandidates[i].index].status == elected) {
            printf("%s%s%s", tdon, electedstr, tdoff);
        } else if (myE->candidates[myE->alphaCandidates[i].index].status == justexcluded) {
            printf("%s%s%s", tdon, jexcstr, tdoff);
            
        } else if (myE->candidates[myE->alphaCandidates[i].index].status == excluded) {
            printf("%s%s%s", tdon, excstr, tdoff);
        } else {
            printf("%s%d%s", tdon, theseVotes[myE->alphaCandidates[i].index], tdoff);
        }
    }
    
    printf("%s%d%s", tdon, exhaustCount, tdoff);
    
    printf("%s%d / %d%s", tdon, tVal.numerator, tVal.denominator, tdoff);
    
    printf(troff);
    
    
}

void printStart(electionDef *myE) {
    int i;
    
    printf(ton);
    printf(tron);
    
    printf("%s%s: Elected, not distributed yet%s", tdon, jelectedstr, tdoff);
    printf(troff);

    printf(tron);

    printf("%s%s: Elected, votes distributed%s", tdon, electedstr, tdoff);
    printf(troff);

    printf(tron);

    printf("%s%s: Excluded, being distributed%s", tdon, jexcstr, tdoff);
    printf(troff);

    printf(tron);

    printf("%s%s: Excluded, votes distributed%s", tdon, excstr, tdoff);

    printf(troff);
    printf(toff);

    printf("<P>\n");
    
    
    
    printf(ton);
    
    
    printf(tron);
    
    printf(tdon);
    printf(tdoff);
    
    
    for (i = 0 ; i < myE->totalPartyCount ; i++) {
     
        printf("<td align=center colspan=%d>%s%s", myE->parties[i].numcand, myE->parties[i].abbrev, tdoff);  
        
    }
    
    printf(troff);
    
    printf(tron);
    
    printf("%sCount%s", tdon, tdoff);
    
    for (i = 0; i < myE->totalCandidateCount ; i++) {
        
        printf("%s%s%s", tdon, myE->candidates[myE->alphaCandidates[i].index].name, tdoff);
        
    }
    
    printf("%sExhausted%s%sTransfer Value%s", tdon, tdoff, tdon, tdoff);
    
    printf(troff);
    
}

void printEnd(electionDef *myE, int countNum) {
    int i;
    
    printf(tron);
    
    printf("%s%d%s", tdon, countNum, tdoff);
    
    for (i = 0; i < myE->totalCandidateCount ; i++) {
        
        if (myE->candidates[myE->alphaCandidates[i].index].status == justelected) {
            printf("%s%s%s", tdon, jelectedstr, tdoff);
            
        } else if (myE->candidates[myE->alphaCandidates[i].index].status == elected) {
            printf("%s%s%s", tdon, electedstr, tdoff);
        } else if (myE->candidates[myE->alphaCandidates[i].index].status == justexcluded) {
            printf("%s%s%s", tdon, jexcstr, tdoff);
            
        } else if (myE->candidates[myE->alphaCandidates[i].index].status == excluded) {
            printf("%s%s%s", tdon, excstr, tdoff);
        } else {
            printf("%s %s", tdon, tdoff);
        }
        
    }
    printf("%s", troff);
    printf("%s", toff);
    
}


